Index: funcs/func_odbc.c
===================================================================
--- funcs/func_odbc.c	(revision 180528)
+++ funcs/func_odbc.c	(working copy)
@@ -55,7 +55,8 @@
 static char *config = "func_odbc.conf";
 
 enum {
-	OPT_ESCAPECOMMAS =	(1 << 0),
+	OPT_ESCAPECOMMAS	= (1 << 0),
+	OPT_READARRAY		= (1 << 1)
 } odbc_option_flags;
 
 struct acf_odbc_query {
@@ -219,7 +220,7 @@
 	struct odbc_obj *obj;
 	struct acf_odbc_query *query;
 	char sql[2048] = "", varname[15];
-	int res, x, buflen = 1, escapecommas, bogus_chan = 0;
+	int res, x, buflen = 1, escapecommas, readarray, bogus_chan = 0;
 	AST_DECLARE_APP_ARGS(args,
 		AST_APP_ARG(field)[100];
 	);
@@ -272,6 +273,7 @@
 
 	/* Save this flag, so we can release the lock */
 	escapecommas = ast_test_flag(query, OPT_ESCAPECOMMAS);
+	readarray = ast_test_flag(query, OPT_READARRAY);
 
 	AST_LIST_UNLOCK(&queries);
 
@@ -349,6 +351,8 @@
 		for (i = 0; i < sizeof(coldata); i++) {
 			if (escapecommas && (coldata[i] == '\\' || coldata[i] == ',')) {
 				buf[buflen++] = '\\';
+				if (readarray)
+					buf[buflen++] = '\\';
 			}
 			buf[buflen++] = coldata[i];
 
@@ -443,6 +447,14 @@
 			ast_clear_flag((*query), OPT_ESCAPECOMMAS);
 	}
 
+	/* When a list is returned double-escape comma's, because Set() will decode backslashes twice
+ 	   (once for pipe's and once for the comma's) */
+	ast_clear_flag((*query), OPT_READARRAY);
+	if ((tmp = ast_variable_retrieve(cfg, catg, "readarray"))) {
+		if (ast_true(tmp))
+			ast_set_flag((*query), OPT_READARRAY);
+	}
+
 	(*query)->acf = ast_calloc(1, sizeof(struct ast_custom_function));
 	if (! (*query)->acf) {
 		free(*query);
